package com.aconiac.apg.domain;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

/*
 * APGGui (DEPRECATED)
 * 
 * The old GUI for the password generator. It is only left here for
 * historical reasons.
 * 
 * @author Morten Slot Kristensen, msk@aconiac.com
 * @deprecated
 * 
 */
public class APGGui extends JFrame {
    private static final int SLIDERLENGTHMIN = 1,
        SLIDERLENGTHMAX = 35,
        SLIDERLENGTHINIT = 12,
        SLIDERAMOUNTMIN = 1,
        SLIDERAMOUNTMAX = 150,
        SLIDERAMOUNTINIT = 1;

    private static final String LOGO = "bin/com/aconiac/apg/gfx/logo_web.png";
    
    private static JSlider sPswLen;
    private static JLabel lblPswLen;
        
    private static JSlider sPswAmount;
    private static JLabel lblPswAmount;

    private static JTextField txtExtraEntropy;
    private static JLabel lblExtraEntropy;

    private static JCheckBox chbNoAnnoying;
    private static JCheckBox chbReqLowCase;
    private static JCheckBox chbReqHighCase;
    private static JCheckBox chbReqDigits;
    private static JCheckBox chbCheckRows;
    private static JCheckBox chbCharAppearance;

    private static JCheckBox chbCharSetZeroToNine;
    private static JCheckBox chbCharSetaToz;
    private static JCheckBox chbCharSetAToZ;
    private static JCheckBox chbCharSetExotic;
    private static JCheckBox chbCharSetNormalSymbols;
    private static JCheckBox chbCharSetExoticSymbols;

    private static JEditorPane txtGenField;
    private static JScrollPane scrollPane;

    private static JRadioButton rbtnPresetMedium;
    private static JRadioButton rbtnPresetHard;
    private static JRadioButton rbtnPresetParanoid;
    private static JRadioButton rbtnPresetCustom;
    private static ButtonGroup presetBtnGroup;

    private static JCheckBox chbUseHash;    
    private static JRadioButton rbtnHashMD5;
    private static JRadioButton rbtnHashSHA1;
    private static JRadioButton rbtnHashSHA256;
    private static JRadioButton rbtnHashSHA512;    
    private static ButtonGroup hashGroup;    

    private static JPanel presetPanel;
    private static JPanel charSetPanel;
    private static JPanel rulesPanel;
    private static JPanel pswPanel;
    private static JPanel hashPanel;

    private static JButton btnGenerate;

    private static JLabel imageLabel;
    private static ImageIcon imageIcon;

    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    APGGui gui = new APGGui();
                }
            });
    }    
    
    public APGGui() {
        initObjects();
        buildRelations();
        setProperties();
    }

    private void initObjects() {
        sPswLen = new JSlider(JSlider.HORIZONTAL, SLIDERLENGTHMIN, SLIDERLENGTHMAX, SLIDERLENGTHINIT);
        lblPswLen = new JLabel("Length of password ("+SLIDERLENGTHINIT+"):");
        
        sPswAmount = new JSlider(JSlider.HORIZONTAL, SLIDERAMOUNTMIN, SLIDERAMOUNTMAX, SLIDERAMOUNTINIT);
        lblPswAmount = new JLabel("Amount of passwords ("+SLIDERAMOUNTINIT+"):");

        txtExtraEntropy = new JTextField(10);
        lblExtraEntropy = new JLabel("Custom chars:");        

        chbNoAnnoying = new JCheckBox("No annoying chars (i,I,o,O,l,L,1)");
        chbReqLowCase = new JCheckBox("Require low-case chars");
        chbReqHighCase = new JCheckBox("Require high-case chars");
        chbReqDigits = new JCheckBox("Require digits");
        chbCheckRows = new JCheckBox("Chars can't come from only one row");
        chbCharAppearance = new JCheckBox("Chars can only appear once");

        chbCharSetZeroToNine = new JCheckBox("[0-9]");
        chbCharSetaToz = new JCheckBox("[a-z]");
        chbCharSetAToZ = new JCheckBox("[A-Z]");
        chbCharSetExotic = new JCheckBox("Exotic chars (not shown)");
        chbCharSetNormalSymbols = new JCheckBox("[.,-_)!?@(/&#]");
        chbCharSetExoticSymbols = new JCheckBox("Exotic symbols (not shown) ");

        txtGenField = new JEditorPane();
        scrollPane = new JScrollPane(txtGenField);

        rbtnPresetMedium = new JRadioButton("Medium");
        rbtnPresetHard = new JRadioButton("Hard", true);
        rbtnPresetParanoid = new JRadioButton("Paranoid");
        rbtnPresetCustom = new JRadioButton("Custom");

        presetBtnGroup = new ButtonGroup();

        chbUseHash = new JCheckBox("Use one?");
        
        rbtnHashMD5 = new JRadioButton("MD5");
        rbtnHashSHA1 = new JRadioButton("SHA1");
        rbtnHashSHA256 = new JRadioButton("SHA256");
        rbtnHashSHA512 = new JRadioButton("SHA512");

        hashGroup = new ButtonGroup();

        presetPanel = new JPanel(new GridLayout(0, 1));
        rulesPanel = new JPanel(new GridLayout(0, 1));
        charSetPanel = new JPanel(new GridLayout(0, 1));
        pswPanel = new JPanel(new GridLayout(0, 1));
        hashPanel = new JPanel(new GridLayout(0, 1));

        btnGenerate = new JButton("Generate");

        //imageIcon = new ImageIcon(getClass().getResource(LOGO), "Aconiac Logo");
        imageLabel = new JLabel(imageIcon);
    }    

    private void buildRelations() {
        presetBtnGroup.add(rbtnPresetMedium);
        presetBtnGroup.add(rbtnPresetHard);
        presetBtnGroup.add(rbtnPresetParanoid);
        presetBtnGroup.add(rbtnPresetCustom);

        hashGroup.add(rbtnHashMD5);
        hashGroup.add(rbtnHashSHA1);
        hashGroup.add(rbtnHashSHA256);
        hashGroup.add(rbtnHashSHA512);

        // the panel with the presets
        presetPanel.add(rbtnPresetMedium);
        presetPanel.add(rbtnPresetHard);
        presetPanel.add(rbtnPresetParanoid);
        presetPanel.add(rbtnPresetCustom);
        presetPanel.setMaximumSize(new Dimension(160, 120));

        // the panel with the char sets
        charSetPanel.add(chbCharSetZeroToNine);
        charSetPanel.add(chbCharSetaToz);
        charSetPanel.add(chbCharSetAToZ);
        charSetPanel.add(chbCharSetExotic);
        charSetPanel.add(chbCharSetNormalSymbols); 
        charSetPanel.add(chbCharSetExoticSymbols);
        charSetPanel.add(lblExtraEntropy);
        charSetPanel.add(txtExtraEntropy);
        charSetPanel.setMaximumSize(new Dimension(170, 180));

        // the panel with the rules
        rulesPanel.add(chbNoAnnoying);
        rulesPanel.add(chbReqLowCase);
        rulesPanel.add(chbReqHighCase);
        rulesPanel.add(chbReqDigits);
        rulesPanel.add(chbCheckRows);
        rulesPanel.add(chbCharAppearance);
        rulesPanel.setMaximumSize(new Dimension(288, 180));        

        // the panel with the password txts
        pswPanel.add(lblPswLen);
        pswPanel.add(sPswLen);
        pswPanel.add(lblPswAmount);        
        pswPanel.add(sPswAmount);
        pswPanel.setMaximumSize(new Dimension(220, 100));

        // the panel with the hash-types
        hashPanel.add(chbUseHash);
        hashPanel.add(rbtnHashMD5);
        hashPanel.add(rbtnHashSHA1);
        hashPanel.add(rbtnHashSHA256);
        hashPanel.add(rbtnHashSHA512);
        hashPanel.setMaximumSize(new Dimension(140, 120));

        // the main content pane
        JPanel panel1 = new JPanel();
        panel1.setLayout(new BoxLayout(panel1, BoxLayout.X_AXIS));
        panel1.add(pswPanel);
        //        panel1.add(Box.createRigidArea(new Dimension(40, 0)));
        panel1.add(presetPanel);
        panel1.add(hashPanel);        
        //        panel1.add(Box.createRigidArea(new Dimension(30, 0)));

        JPanel panel2 = new JPanel();
        panel2.setLayout(new BoxLayout(panel2, BoxLayout.X_AXIS));
        panel2.add(charSetPanel);
        panel2.add(rulesPanel);

        JPanel panel3 = new JPanel();
        panel3.setLayout(new BoxLayout(panel3, BoxLayout.X_AXIS));
        panel3.add(scrollPane);

        JPanel panel4 = new JPanel();
        panel4.setLayout(new BoxLayout(panel4, BoxLayout.X_AXIS));
        panel4.add(btnGenerate);        

        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
        mainPanel.add(panel1);        
        mainPanel.add(panel2);
        mainPanel.add(panel3);
        mainPanel.add(panel4);
      
        Container contentPane = this.getContentPane();
        contentPane.add(imageLabel, BorderLayout.SOUTH);
        contentPane.add(mainPanel, BorderLayout.CENTER);
        pack();   
    }

    private int getHowManyReqRulesChecked() {
        int res = 0;
        if(chbReqLowCase.isSelected())
            res++;
        if(chbReqHighCase.isSelected())
            res++;
        if(chbReqDigits.isSelected())
            res++;        
        return res;
    }

    private void rulesCheck(JCheckBox ruleBox, JCheckBox rangeBox) {
        if(ruleBox.isSelected() && !rangeBox.isSelected()) {
            ruleBox.setSelected(false);
            int num = 1;
            if(ruleBox == chbReqDigits)
                num = 1;
            else if(ruleBox == chbReqLowCase)
                num = 2;
            else if(ruleBox == chbReqHighCase)
                num = 3;
            showUsage(num);
        } else if(getHowManyReqRulesChecked() > sPswLen.getValue()) {
            ruleBox.setSelected(false);
            showUsage(4);                            
        }        
    }

    private void setProperties() {
        setTitle("Aconiac Password Generator");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(500, 700);
        setVisible(true);

        txtGenField.setEditable(false);
        txtGenField.setContentType("text/html");

        chbUseHash.setSelected(false);

        rbtnHashMD5.setSelected(true);
        rbtnHashMD5.setEnabled(false);
        rbtnHashSHA1.setEnabled(false);
        rbtnHashSHA256.setEnabled(false);
        rbtnHashSHA512.setEnabled(false);

        // default is 'hard' preset
        chbCharSetZeroToNine.setSelected(true);
        chbCharSetaToz.setSelected(true);
        chbCharSetAToZ.setSelected(true);
        chbCharSetNormalSymbols.setSelected(false);
        chbCharSetExoticSymbols.setSelected(false);
        chbCharSetExotic.setSelected(false);

        // .. and with all rules on
        chbReqDigits.setSelected(true);
        chbReqLowCase.setSelected(true);
        chbReqHighCase.setSelected(true);
        chbNoAnnoying.setSelected(true);
        chbCheckRows.setSelected(true);

        sPswLen.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent event) {
                    lblPswLen.setText("Length of password ("+sPswLen.getValue()+"):");
                    if(getHowManyReqRulesChecked() > sPswLen.getValue()) {
                        chbReqLowCase.setSelected(false);
                        chbReqHighCase.setSelected(false);
                        chbReqDigits.setSelected(false);
                        showUsage(4);
                    }
                    if(sPswLen.getValue() == 1 && chbCheckRows.isSelected()) {
                        chbCheckRows.setSelected(false);
                        showUsage(7);
                    }
                }
            });

        sPswAmount.addChangeListener(new ChangeListener() {
                public void stateChanged(ChangeEvent event) {
                    lblPswAmount.setText("Amount of passwords ("+sPswAmount.getValue()+"):");
                }
            });        

        presetPanel.setBorder(BorderFactory.
                              createCompoundBorder(BorderFactory.createTitledBorder("Presets:"),
                                                   BorderFactory.createEmptyBorder(5,5,5,5)));

        rulesPanel.setBorder(BorderFactory.
                             createCompoundBorder(
                                                  BorderFactory.createTitledBorder("Rules to apply:"),
                                                  BorderFactory.createEmptyBorder(5,5,5,5)));

        charSetPanel.setBorder(BorderFactory.
                               createCompoundBorder(
                                                    BorderFactory.createTitledBorder("Character sets to use:"),
                                                    BorderFactory.createEmptyBorder(5,5,5,5)));

        hashPanel.setBorder(BorderFactory.
                            createCompoundBorder(
                                                 BorderFactory.createTitledBorder("Hash algorithms:"),
                                                 BorderFactory.createEmptyBorder(5,5,5,5)));

        chbUseHash.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JCheckBox box = (JCheckBox) event.getSource();
                    if(box.isSelected()) {
                        rbtnHashMD5.setEnabled(true);
                        rbtnHashSHA1.setEnabled(true);
                        rbtnHashSHA256.setEnabled(true);
                        rbtnHashSHA512.setEnabled(true); 
                    } else {
                        rbtnHashMD5.setEnabled(false);
                        rbtnHashSHA1.setEnabled(false);
                        rbtnHashSHA256.setEnabled(false);
                        rbtnHashSHA512.setEnabled(false);
                    }
                }
            });
        
        chbCharSetZeroToNine.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JCheckBox box = (JCheckBox) event.getSource();
                    rbtnPresetCustom.setSelected(true);
                    if(!box.isSelected())
                        chbReqDigits.setSelected(false);
                }
            });

        chbCharSetaToz.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JCheckBox box = (JCheckBox) event.getSource();
                    rbtnPresetCustom.setSelected(true);
                    if(!box.isSelected())
                        chbReqLowCase.setSelected(false);                    
                }
            });

        chbCharSetAToZ.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    JCheckBox box = (JCheckBox) event.getSource();
                    rbtnPresetCustom.setSelected(true);
                    if(!box.isSelected())
                        chbReqHighCase.setSelected(false);
                }
            });

        chbCharSetExoticSymbols.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rbtnPresetCustom.setSelected(true);
                }
            });

        chbCharSetExotic.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rbtnPresetCustom.setSelected(true);
                }
            });

        chbCharSetNormalSymbols.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rbtnPresetCustom.setSelected(true);
                }
            });

        chbReqDigits.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rulesCheck(chbReqDigits, chbCharSetZeroToNine);
                }
            });

        chbReqLowCase.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rulesCheck(chbReqLowCase, chbCharSetaToz);                    
                }
            });

        chbReqHighCase.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    rulesCheck(chbReqHighCase, chbCharSetAToZ);                    
                }
            });                        

        rbtnPresetMedium.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    chbCharSetZeroToNine.setSelected(false);
                    chbCharSetaToz.setSelected(true);
                    chbCharSetAToZ.setSelected(true);
                    chbCharSetNormalSymbols.setSelected(false);
                    chbCharSetExoticSymbols.setSelected(false);
                    chbCharSetExotic.setSelected(false);
                    
                    chbReqDigits.setSelected(false);

                    sPswLen.setValue(8);
                }
            });

        rbtnPresetHard.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    chbCharSetZeroToNine.setSelected(true);
                    chbCharSetaToz.setSelected(true);
                    chbCharSetAToZ.setSelected(true);
                    chbCharSetNormalSymbols.setSelected(false);
                    chbCharSetExoticSymbols.setSelected(false);
                    chbCharSetExotic.setSelected(false);

                    sPswLen.setValue(12);
                }
            });

        rbtnPresetParanoid.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    chbCharSetZeroToNine.setSelected(true);
                    chbCharSetaToz.setSelected(true);
                    chbCharSetAToZ.setSelected(true);
                    chbCharSetNormalSymbols.setSelected(true);
                    chbCharSetExoticSymbols.setSelected(true);
                    chbCharSetExotic.setSelected(true);

                    sPswLen.setValue(25);
                }
            });                
        
        btnGenerate.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent event) {
                    PasswordGenerator gen = new PasswordGeneratorImpl();
                    Hasher hasher = new HasherImpl();

                    // determine if a character-set were given and use them
                    int pswLen = sPswLen.getValue();

                    // verify amount of passwords to generate is a number
                    int pswAmount = sPswAmount.getValue();
                    
                    String charSet = "",
                        oldCharSet = gen.getCharacterSet();
                    
                    if(chbNoAnnoying.isSelected())
                        gen.addRule(new NoAnnoyingCharsRule());
                    if(chbReqLowCase.isSelected())
                        gen.addRule(new HasLowCaseCharsRule());
                    if(chbReqHighCase.isSelected())
                        gen.addRule(new HasHighCaseCharsRule());
                    if(chbReqDigits.isSelected())
                        gen.addRule(new HasNumbersRule());
                    if(chbCheckRows.isSelected())
                        gen.addRule(new CheckRowOriginRule());                    
                    if(chbCharAppearance.isSelected())
                        gen.addRule(new SingleAppearanceCharRule());                    
                    if(chbCharSetZeroToNine.isSelected())
                        charSet += PasswordGeneratorImpl.Zero_Through_Nine_SET;
                    if(chbCharSetaToz.isSelected())
                        charSet += PasswordGeneratorImpl.a_Through_z_SET;
                    if(chbCharSetAToZ.isSelected())
                        charSet += PasswordGeneratorImpl.A_Through_Z_SET;
                    if(chbCharSetExotic.isSelected())
                        charSet += PasswordGeneratorImpl.Exotic_Characters_SET;
                    if(chbCharSetNormalSymbols.isSelected())
                        charSet += PasswordGeneratorImpl.Normal_Symbols_SET;
                    if(chbCharSetExoticSymbols.isSelected())
                        charSet += PasswordGeneratorImpl.Exotic_Symbols_SET;

                    String customChar = txtExtraEntropy.getText();
                    charSet += customChar;
                    
                    // if no options for character sets were set then use default
                    if(charSet.equals("")) gen.setCharacterSet(oldCharSet);
                    // else use them
                    else gen.setCharacterSet(charSet);

                    // check charset for row rule
                    if(chbCheckRows.isSelected()) {
                        Rule r = new CheckRowOriginRule();
                        if(!r.isValid(gen.getCharacterSet())) {
                            showUsage(5);
                            return;
                        }
                    }

                    // check that if SingleAppearanceCharRule is selected
                    // the charset has to be longer or as long as  the 
                    // length of passwords to generate
                    if(chbCharAppearance.isSelected()) {
                        if(gen.getCharacterSet().length() < pswLen) {
                            showUsage(6);
                            return;
                        }
                    }

                    // should there be generated hashes as well?
                    boolean useHashes = false;
                    HashAlg alg = null;
                    if(chbUseHash.isSelected()) {
                        useHashes = true;
                        if(rbtnHashMD5.isSelected())
                            alg = HashAlg.MD5;
                        else if(rbtnHashSHA1.isSelected())
                            alg = HashAlg.SHA1;
                        else if(rbtnHashSHA256.isSelected())
                            alg = HashAlg.SHA256;
                        else if(rbtnHashSHA512.isSelected())
                            alg = HashAlg.SHA512;                        
                    }
                    
                    // generate password
                    ArrayList<String> list = new ArrayList<String>();
                    int charSetSize = gen.getCharacterSet().length();
                    double entropyBits = gen.checkStrength(pswLen, charSetSize);
                    String text = "<font size=3 face=verdana>"+
                        "Generating "+pswAmount+" password(s) of length "+pswLen+":<br>"+
                        "Password strength: "+(int)entropyBits+" bits<br>"+
                        "Level og protection: "+gen.strengthDescription(entropyBits)+"<br>" +
                        "<table border=1 cellpadding=2 cellspacing=0><th>Password</th>";

                    if(useHashes) text += "<th>"+alg+" Hash</th>";
                    for(int k = 0; k < pswAmount; k++) {
                        text += "<tr><td><font size=3 face=verdana>";
                        String psw = "";

                        // keep generating until a password is found that does not
                        // exist already
                        while(true) {
                            psw = gen.generate(pswLen);
                            if(!list.contains(psw)) {
                                list.add(psw);
                                break;
                            }
                        }
                        
                        text += psw + "</font></td>";
                        if(useHashes)
                            text += "<td><font size=3 face=verdana>"+
                                hasher.genHexStringHash(psw, alg)+
                                "</font></td>";
                        text += "</tr>";
                    }
                    text += "</table></font>";
                    txtGenField.setText(text);
                }
            });
    }
    
    private void showUsage(int num) {
        String message = "";

        switch(num) {
        case 1:
            message = "You cannot require to get digits when not using the character range [0-9]!";
            break;
        case 2:
            message = "You cannot require to get low case characters when not using the character range [a-z]!";
            break;
        case 3:
            message = "You cannot require to get upper case characters when not using the character range [A-Z]!";
            break;
        case 4:
            message = "You cannot require to get upper case characters, low case characters\nand digits when trying to generate a password of length\n3 or less! Each rule requires at least one character to pass.";
            break;
        case 5:
            message = "Your chosen character set cannot generate passwords that does not only\noriginate from one row of the keyboard!\nThese are illegal examples: qwerty, 123, ghjk etc.";
            break;
        case 6:
            message = "Your chosen character set is too short!\nIf characters cannot appear more than once then the character set needs to be as long or longer than the length of passwords to generate!";
            break;
        case 7:
            message = "When characters cannot originate from only\none row then the password length cannot be 1 (one)!";
            break;
        }
        
        
        JOptionPane.showMessageDialog(this, message);
    }
}