package com.aconiac.apg.domain;
/*
 * Rule that checks if a password is from only one single row on the
 * keyboard (QWERTY ONLY!).
 *
 * Examples are: qwerty, 123, ghjk etc.
 */ 

public class CheckRowOriginRule implements Rule {
    private String[] rows = {"1234567890+§!\"#¤%&/()=?¡@£$½¥{[]}±|´`",
                             "ûÛêÊúÚöÖåÅéÉóÓèÈëËùÙý?í?ï?üÜôÔîÎqwertyuioìÌòÒpåQWERTYÿŸUIOPÅ^~",
                             "à?âÂáÀäÄasdfghjklæøASDFGHJKLÆØ*'",
                             "zxcvbnmZXCVBNM,.-;:_<>\\"};
    
    public boolean isValid(String password) {
        int counter[] = {0, 0, 0, 0};
        for(int i = 0; i < rows.length; i++) {
            for(int j = 0; j < password.length(); j++) {
                if(rows[i].indexOf(password.charAt(j)) != -1)
                    counter[i]++;
            }
        }

        int count = 0;
        for(int i = 0; i < rows.length; i++)
            if(counter[i] == 0)
                count++;

        if(count == 3)
            return false;
        else
            return true;
    }
}