package com.aconiac.apg.misc;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class ListJre {
	public static void main(String[] args) {
		//System.out.println(TraverseDirectory("installer/jre"));
		String out = TraverseDirectory("installer/jre");
		try {
			PrintWriter p = new PrintWriter(new BufferedWriter(new FileWriter("installer/jre.ahk")));
			p.write(out);
			p.close();
			System.out.println("Success!");
		} catch(IOException e) {
			System.out.println("Error occurred: " + e.getMessage());
		}
	}
	
	private static String TraverseDirectory(String root) {
		File f = new File(root);
		if(!f.isDirectory()) throw new IllegalArgumentException("Given root was not a directory!");
		
		String out = "";
		String finalRoot = root.replaceAll("^installer/", "");
		
		for(String s : f.list()) {
			File f2 = new File(root + "\\" + s);
			
			if(f2.isDirectory()) {
				//System.out.println("FileCreateDir, " + root + "\\" + s);
				out += "FileCreateDir, " + finalRoot + "\\" + s + "\n";
				out += TraverseDirectory(root + "\\" + s);
			} else if(f2.isFile()){
				//System.out.println("FileInstall, " + root + "\\" + s + ", " + root + "\\" + s );
				out += "FileInstall, " + finalRoot + "\\" + s + ", " + finalRoot + "\\" + s + ", 0\n";
			} else {
				System.out.println("Problem with: " + root + s + ", unknown file/dir");
				System.exit(0);
			}
		}
		
		return out;
	}
}