package com.aconiac.apg.test;
import org.junit.*;
import static org.junit.Assert.*;
import com.aconiac.apg.domain.*;

public class TestHasher {
    private Hasher hasher;
    @Before public void setup() {
        hasher = new HasherImpl();
    }

    @Test public void testShouldByteNotBeNullWithMD5() {
        assertNotNull(hasher.genByteHash("test", HashAlg.MD5));
    }

    @Test public void testShouldByteBe16BytesLongMD5() {
        byte[] hash = hasher.genByteHash("test", HashAlg.MD5);
        assertEquals(16, hash.length);
    }

    @Test public void testShouldStrNotBeNullWithMD5() {
        String hash = hasher.genHexStringHash("test", HashAlg.MD5);
        assertNotNull(hash);
    }

    @Test public void testShouldStrBe31CharsLongMD5() {
        String hash = hasher.genHexStringHash("test", HashAlg.MD5);
        assertEquals(31, hash.length());
    }

    @Test public void testShouldStrNotBeNullWithSHA1() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA1);
        assertNotNull(hash);
    }    
    
    @Test public void testShouldStrBe31CharsLongSHA1() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA1);
        assertEquals(39, hash.length());
    }

    @Test public void testShouldStrNotBeNullWithSHA256() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA256);
        assertNotNull(hash);
    }

    @Test public void testShouldStrBe54CharsLongSHA256() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA256);
        assertEquals(61, hash.length());
    }

    @Test public void testShouldStrNotBeNullWithSHA512() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA512);
        assertNotNull(hash);
    }    

    @Test public void testShouldStrBe115CharsLongSHA512() {
        String hash = hasher.genHexStringHash("test", HashAlg.SHA512);
        assertEquals(123, hash.length());
    }
    
    /** This wrapper is only required for running the old JUnit 3.8
     * graphical user interface on new JUnit 4 test cases */
    public static junit.framework.Test suite() {
        return new junit.framework.JUnit4TestAdapter(TestHasher.class);
    } 
}
